package polaris.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
public @interface URLAPI {

	/**
	 * Returns host name.
	 * 
	 * @return host name.
	 */
	public String host();

	/**
	 * Return the port, the default port is 80.
	 * 
	 * @return the port.
	 */
	public int port() default 80;

	/**
	 * Returns the API URI.
	 * 
	 * @return the API URI.
	 */
	public String uri();

	/**
	 * Returns the scheme of the URL.
	 * 
	 * @return the scheme of the URL
	 */
	public String scheme() default "http";

}
