package polaris.application;

import java.io.File;

/**
 * {@link AbstractApplication}
 * 
 * @author johnson
 * 
 */
public abstract class AbstractApplication implements Application {
	protected String name;
	protected Version version;

	@Override
	public String getName() {
		return new File(this.name).getName();
	}

	@Override
	public int getMajorVersion() {
		return this.version.major;
	}

	@Override
	public int getMinorVersion() {
		return this.version.minor;
	}

	@Override
	public File getWorkDirectory() {
		return new File(System.getProperty("user.dir"));
	}

	@Override
	public File getTempDirectory() {
		return new File(System.getProperty("java.io.tmpdir"));
	}

}
