package polaris.application;

import java.io.File;

/**
 * Generic application interface
 * 
 * @author johnson
 * 
 */
public interface Application {

	/**
	 * Return application name.
	 * 
	 * @return the application name
	 */
	public String getName();

	/**
	 * Return the major version.
	 * 
	 * @return the major version.
	 */
	public int getMajorVersion();

	/**
	 * Return the minor version.
	 * 
	 * @return the minor version.
	 */
	public int getMinorVersion();

	/**
	 * Return the work directory absolute path.
	 * 
	 * @return the work directory absolute path.
	 */
	public File getWorkDirectory();

	/**
	 * Return the temporary directory absolute path.
	 * 
	 * @return the temporary directory absolute path.
	 */
	public File getTempDirectory();

}
