package polaris.io;

import java.io.ByteArrayOutputStream;
import java.io.CharArrayWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;

public abstract class Stream {

	private Stream() {
	}

	public static String readAsString(InputStream in) throws IOException {
		int len = 0;
		byte[] buf = new byte[4096];
		ByteArrayOutputStream bos = new ByteArrayOutputStream();

		try {
			while ((len = in.read(buf, 0, buf.length)) > 0) {
				bos.write(buf, 0, len);
			}

			bos.flush();

			return bos.toString();
		} finally {
			if (null != bos) {
				bos.close();
			}
		}
	}

	public static String readAsString(Reader in) throws IOException {
		int len = 0;
		char[] buf = new char[4096];
		CharArrayWriter caw = new CharArrayWriter();

		try {
			while ((len = in.read(buf, 0, buf.length)) > 0) {
				caw.write(buf, 0, len);
			}

			caw.flush();

			return caw.toString();
		} finally {
			if (null != caw) {
				caw.close();
			}
		}
	}

}
