package polaris.reflect;

public interface Introspector<T> extends Getter<T>, Setter<T> {

	/**
	 * Return the introspected object.
	 * 
	 * @return The introspected object.
	 */
	public T get();

	/**
	 * Set the introspected object with specify value.
	 * 
	 * @param t
	 *            An object which to be introspected.
	 */
	public void set(T t);

	/**
	 * Return all attribute name of the introspected object.
	 * 
	 * @return All attribute names.
	 */
	public String[] getAttributeNames();

	/**
	 * Test whether the introspected object has the specified attribute.
	 * 
	 * @param name
	 *            Attribute name.
	 * @return true if only the introspected object has an accessible attribute
	 *         with specified name.
	 */
	public boolean hasAttribute(String name);
}
