package polaris.reflect;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

@SuppressWarnings("rawtypes")
public class MapIntrospector extends GenericIntrospector<Map> {

	public MapIntrospector(Map obj) {
		super(obj);
	}

	@Override
	public Object get(String name) throws IllegalAccessException {
		Object obj = super.get(name);

		if (null == obj) {
			obj = this.obj.get(name);
		}

		return obj;
	}

	@Override
	@SuppressWarnings("unchecked")
	public void set(String name, Object value) throws IllegalAccessException {
		if (super.hasAttribute(name)) {
			super.set(name, value);
		} else {
			this.obj.put(name, value);
		}
	}

	@Override
	public String[] getAttributeNames() {
		String[] attrs = super.getAttributeNames();
		List<String> names = new ArrayList<String>();

		for (String attr : attrs) {
			names.add(attr);
		}

		Set<?> keys = this.obj.keySet();
		for (Object obj : keys) {
			if (obj instanceof String) {
				names.add((String) obj);
			}
		}

		return names.toArray(new String[names.size()]);
	}

	@Override
	public boolean hasAttribute(String name) {
		return super.hasAttribute(name) || this.obj.containsKey(name);
	}

}
